---
id: 5900f3b61000cf542c50fec9
title: 'Problema 74: Cadeia de fatoriais'
challengeType: 5
forumTopicId: 302187
dashedName: problem-74-digit-factorial-chains
---

# --description--

O número 145 é conhecido pela propriedade onde a soma do fatorial de seus algarismos é igual a 145:

$$1! + 4! + 5! = 1 + 24 + 120 = 145$$

Talvez 169 seja menos conhecido. Esse número produz a maior cadeia de números que remonta a 169. Acontece que existem apenas três desses laços:

$$\begin{align} &169 → 363601 → 1454 → 169\\\\ &871 → 45361 → 871\\\\ &872 → 45362 → 872\\\\ \end{align}$$

Não é difícil provar que TODOS os números com que você iniciar ficarão presos em um ciclo. Por exemplo:

$$\begin{align} &69 → 363600 → 1454 → 169 → 363601\\ (→ 1454)\\\\ &78 → 45360 → 871 → 45361\\ (→ 871)\\\\ &540 → 145\\ (→ 145)\\\\ \end{align}$$

O número 69 produz uma cadeia de cinco termos sem repetição. A cadeia de maior número sem repetição, iniciando com um número abaixo de um milhão, é de sessenta termos.

Quantas cadeias, com um número inicial abaixo de `n`, contém exatamente sessenta termos não repetidos?

# --hints--

`digitFactorialChains(2000)` deve retornar um número.

```js
assert(typeof digitFactorialChains(2000) === 'number');
```

`digitFactorialChains(2000)` deve retornar `6`.

```js
assert.strictEqual(digitFactorialChains(2000), 6);
```

`digitFactorialChains(100000)` deve retornar `42`.

```js
assert.strictEqual(digitFactorialChains(100000), 42);
```

`digitFactorialChains(500000)` deve retornar `282`.

```js
assert.strictEqual(digitFactorialChains(500000), 282);
```

`digitFactorialChains(1000000)` deve retornar `402`.

```js
assert.strictEqual(digitFactorialChains(1000000), 402);
```

# --seed--

## --seed-contents--

```js
function digitFactorialChains(n) {

  return true;
}

digitFactorialChains(2000);
```

# --solutions--

```js
function digitFactorialChains(n) {
  function sumDigitsFactorials(number) {
    let sum = 0;
    while (number > 0) {
      sum += factorials[number % 10];
      number = Math.floor(number / 10);
    }
    return sum;
  }

  const factorials = [1];
  for (let i = 1; i < 10; i++) {
    factorials.push(factorials[factorials.length - 1] * i);
  }

  const sequences = {
    169: 3,
    871: 2,
    872: 2,
    1454: 3,
    45362: 2,
    45461: 2,
    3693601: 3
  };
  let result = 0;

  for (let i = 2; i < n; i++) {
    let curNum = i;
    let chainLength = 0;
    const curSequence = [];
    while (curSequence.indexOf(curNum) === -1) {
      curSequence.push(curNum);
      curNum = sumDigitsFactorials(curNum);
      chainLength++;
      if (sequences.hasOwnProperty(curNum) > 0) {
        chainLength += sequences[curNum];
        break;
      }
    }
    if (chainLength === 60) {
      result++;
    }
    for (let j = 1; j < curSequence.length; j++) {
      sequences[curSequence[j]] = chainLength - j;
    }
  }
  return result;
}
```
