---
id: 5a23c84252665b21eecc8002
title: Алгоритми сортування/Випадкове сортування
challengeType: 5
forumTopicId: 302311
dashedName: sorting-algorithmsbogosort
---

# --description--

[випадкове сортування](https://en.wikipedia.org/wiki/Bogosort) – це список чисел.

Випадкове сортування просто перемішує набір елементів випадковим чином, поки він не упорядкований.

«Випадкове сортування» – помилковий, неефективний алгоритм, який використовується лише як жарт.

Середній час його виконання становить O(n!), бо ймовірність того, що будь-яке перемішування набору закінчиться у відсортованому порядку, становить приблизно один у *n* факторіалі, а в гіршому випадку – нескінченність, оскільки немає гарантії, що випадкове перемішування коли-небудь призведе до упорядкованої послідовності.

Кращим випадком є O(n), оскільки одного проходження по елементах може бути достатньо, щоб упорядкувати їх.

Псевдокод:

<pre><b>while not</b> InOrder(list) <b>do</b>
  Shuffle(list)
<b>done</b>
</pre>

# --hints--

`bogosort` має бути функцією.

```js
assert(typeof bogosort == 'function');
```

`bogosort([25, 32, 12, 7, 20])` має повернути масив.

```js
assert(Array.isArray(bogosort([25, 32, 12, 7, 20])));
```

`bogosort([25, 32, 12, 7, 20])` має повернути `[7, 12, 20, 25, 32]`.

```js
assert.deepEqual(bogosort([25, 32, 12, 7, 20]), [7, 12, 20, 25, 32]);
```

`bogosort([38, 45, 35, 8, 13])` має повернути `[8, 13, 35, 38, 45]`.

```js
assert.deepEqual(bogosort([38, 45, 35, 8, 13]), [8, 13, 35, 38, 45]);
```

`bogosort([43, 36, 20, 34, 24])` має повернути `[20, 24, 34, 36, 43]`.

```js
assert.deepEqual(bogosort([43, 36, 20, 34, 24]), [20, 24, 34, 36, 43]);
```

`bogosort([12, 33, 26, 18, 1, 16, 38])` має повернути `[1, 12, 16, 18, 26, 33, 38]`.

```js
assert.deepEqual(bogosort([12, 33, 26, 18, 1, 16, 38]), [
  1,
  12,
  16,
  18,
  26,
  33,
  38
]);
```

`bogosort([3, 39, 48, 16, 1, 4, 29])` має повернути `[1, 3, 4, 16, 29, 39, 48]`.

```js
assert.deepEqual(bogosort([3, 39, 48, 16, 1, 4, 29]), [
  1,
  3,
  4,
  16,
  29,
  39,
  48
]);
```

# --seed--

## --seed-contents--

```js
function bogosort(v) {

}
```

# --solutions--

```js
function bogosort(v) {
  function shuffle(v) {
    for (
      var j, x, i = v.length;
      i;
      j = Math.floor(Math.random() * i), x = v[--i], v[i] = v[j], v[j] = x
    );
    return v;
  }

  function isSorted(v) {
    for (var i = 1; i < v.length; i++) {
      if (v[i - 1] > v[i]) {
        return false;
      }
    }
    return true;
  }
  var sorted = false;
  while (sorted == false) {
    v = shuffle(v);
    sorted = isSorted(v);
  }
  return v;
}
```
