### Soy nuevo en GitHub y Open Source. ¿Dónde debo empezar?

Lee nuestra ["Guía de como contribuir a Open Source"](https://github.com/freeCodeCamp/how-to-contribute-to-open-source). Es una referencia completa para proyectos aptos para principiantes. E incluye muchos consejos de contribución de código abierto.

### ¿Qué necesito saber para contribuir al código base?

freeCodeCamp se ejecuta en una moderna plataforma de JavaScript. Si estás interesado en contribuir a nuestra base de código, necesitarás cierta familiaridad con JavaScript y algunas de las tecnologías que usamos como Node.js, MongoDB, OAuth 2.0, React, Gatsby, y Webpack.

### ¿Puedo traducir los recursos de freeCodeCamp?

Sí - Puedes contribuir cualquiera de los más de 30 idiomas que hemos habilitado en nuestra plataforma de traducción.

Tenemos traducciones hechas por usuarios nativos en algunos idiomas. Tenemos la intención de traducir freeCodeCamp a los principales idiomas del mundo. Puedes leer todo acerca de esto en nuestro [anuncio aquí](https://www.freecodecamp.org/news/world-language-translation-effort).

Si estás interesado en ayudar a traducir, por favor asegúrate de [leer esta guía](how-to-translate-files.md) primero.

### Puedo contribuír con artículos a las Noticias de freeCodeCamp o con vídeos al canal de YouTube de freeCodeCamp?

Sí - puedes contribuir a las publicaciones de nuestro blog y canal de YouTube.

Si estás interesade en escribir artículos para las Noticias de freeCodeCamp, por favor visita esta [guía de publicaciones](https://www.freecodecamp.org/news/how-to-write-for-freecodecamp/). Además, por favor lea nuestra [guía de estilo](https://www.freecodecamp.org/news/developer-news-style-guide/) ya que esto le ayudará a escribir artículos más fuertes y efectivos.

Para ayudarnos a crear vídeos educacionales para nuestro canal de YouTube, puedes seguir la [guía del canal de YouTube](https://www.freecodecamp.org/news/how-to-contribute-to-the-freecodecamp-community-youtube-channel-b86bce4c865/).

### Cómo puedo reportar un nuevo error?

Si crees que has encontrado un error, primero lee el artículo ["Ayuda, he encontrado un bug"](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) y sigue sus instrucciones.

Si estás seguro de que es un error nuevo, crea un tema de GitHub nuevo.  Asegúrate de incluir tanta información como sea posible para que podamos reproducir el error.  Tenemos una plantilla de informe predefinida para ayudarte con esto.

Ten en cuenta que estos temas de GitHub son para debates y problemas relacionados al código base, no para obtener ayuda para aprender a programar. Whenever in doubt, you should [seek assistance on the forum](https://forum.freecodecamp.org) before creating a GitHub issue.

### ¿Cómo puedo reportar un problema de seguridad?

Please don't create GitHub issues for security issues. Instead, please send an email to `security@freecodecamp.org` and we'll look into it immediately.

### Soy estudiante. ¿Puedo trabajar en una característica para los créditos académicos?

Sí. Please note we are unable to commit to any timelines or paperwork that may be a requirement by your college or university. We receive many pull-requests and code contributions from volunteer developers, and we respect their time and efforts. Out of respect for all of our other contributors, we will not give any PR special priority just because it happens to be school-related.

We request you to plan ahead and work on code contributions with this in mind.

### What do these different labels that are tagged on issues mean?

The code maintainers [triage](https://en.wikipedia.org/wiki/Software_bug#Bug_management) issues and pull requests based on their priority, severity, and other factors. You can [find a complete glossary of their meanings here](https://github.com/freecodecamp/freecodecamp/labels).

### Where do I start if I want to work on an issue?

You should go through [**`help wanted`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22help+wanted%22) or [**`first timers only`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22first+timers+only%22) issues for a quick overview of what is available for you to work on.

> [!TIP] Los temas de **`se busca ayuda`** están en marcha y no es necesario pedir permiso antes de trabajar en ellos. Sin embargo, temas con la etiqueta **`solo principiantes`** son temas especiales que están diseñados para personas que no han contribuido a la base de código de freeCodeCamp antes.

### Encontré un error tipográfico. Should I report an issue before I can make a pull request?

For typos and other wording changes, you can directly open pull requests without creating an issue first. Please be sure to mention details in the pull request description to help us understand and review your contribution – even if it's just a minor change.

Please do create an issue if you want to discuss bigger aspects of the codebase or curriculum.

### How can I get an issue assigned to me?

We typically do not assign issues to anyone other than long-time contributors. Instead, we follow the below policy to be fair to everyone:

1. Lo más probable es que fusionemos el primer pull request que aborde el tema o problema.
2. En el caso de múltiples colaboradores abriendo un pull request para el mismo problema más o menos al mismo tiempo, daremos prioridad al pull request que aborde mejor la cuestión. Algunas de las cosas que consideramos:
   - ¿Has incluido pruebas?
   - ¿Has detectado todos los casos de usos?
   - ¿Te aseguraste de que pasaran todas las pruebas, y confirmaste que todo funciona localmente?
3. Por último, damos prioridad a los pull requests que siguen nuestras directrices recomendadas.
   - ¿Has seguido la lista de verificación de pull request?
   - ¿Has dado a tu pull request un título significativo?

### I am interested in being a moderator at freeCodeCamp. Where should I start?

Our community moderators are our heroes. Their voluntary contributions make freeCodeCamp a safe and welcoming community.

First and foremost, we would need you to be an active participant in the community, and live by our [code of conduct](https://www.freecodecamp.org/news/code-of-conduct/) (not just enforce it).

Here are some recommended paths for some of our platforms:

- To be a **Discord/Chat** moderator, have an active presence in our chat and have positive engagements with others, while also learning and practicing how to deal with potential conflicts that may arise.
- To be a **Forum** moderator, similar to a chat moderator, have an active presence and engage with other forum posters, supporting others in their learning journey, and even given feedback when asked. Take a look at [The Subforum Leader Handbook](https://forum.freecodecamp.org/t/the-subforum-leader-handbook/326326) for more information.
- To be a **GitHub** moderator, help process GitHub issues that are brought up to see if they are valid and (ideally) try to propose solutions for these issues to be picked up by others (or yourself).

Altogether, be respectful to others. We are humans all around the world. With that in mind, please also consider using encouraging or supportive language and be mindful of cross-cultural communication.

If you practice the above **consistently for a while** and our fellow moderator members recommend you, a staff member will reach out and onboard you to the moderators' team. El trabajo de código abierto es voluntario, y nuestro tiempo es limitado. We acknowledge that this is probably true in your case as well. So we emphasize being **consistent** rather than engaging in the community 24/7.

Take a look at our [Moderator Handbook](moderator-handbook.md) for a more exhaustive list of other responsibilities and expectations we have of our moderators.

### I am stuck on something that is not included in this documentation.

**Feel free to ask for help in:**

- The `Contributors` category of [our community forum](https://forum.freecodecamp.org/c/contributors).
- The `#Contributors` channel on [our chat server](https://chat.freecodecamp.org/channel/contributors).

We are excited to help you contribute to any of the topics that you would like to work on. If you ask us questions on the related issue threads, we will be glad to clarify. Be sure to search for your question before posting a new one.

Thanks in advance for being polite and patient. Remember – this community is run mainly by volunteers.

### Additional Assistance

If you have queries about the stack, architecture of the codebase, translations, or anything else feel free to reach out to our staff team [on the forum](https://forum.freecodecamp.org/g/team).

**You can email our developer staff at: `dev[at]freecodecamp.org`**
