# Como revisar traducciones

Nuestro equipo de revisión es responsable de garantizar que las traducciones reflejen con precisión el texto original. Confiamos en nuestro equipo de revisión para asegurarnos de que tenemos traducciones de muy alta calidad.

Todas nuestras traducciones están hechas a mano, por humanos reales. La revisión garantiza que haya un tono coherente en todos nuestros recursos traducidos, como el plan de estudios.

Para comenzar a revisar, visita [nuestra plataforma de traducción](https://translate.freecodecamp.org) e inicia sesión. Selecciona "Ir a la consola" en la barra de navegación superior para cambiar de la vista pública a la vista de espacio de trabajo.

## Seleccionar un archivo

Verás la lista de proyectos a los que se le ha otorgado acceso. Selecciona el proyecto que te gustaría revisar y luego selecciona el idioma.

![Imagen - Árbol de archivos de revisión](https://contribute.freecodecamp.org/images/crowdin/proof-file-tree.png)

Ahora podrás ver la lista de archivos disponibles. Elige tu archivo seleccionando el botón `Proofread` a la derecha de ese archivo, luego elige `Proofreading` en el menú desplegable que aparece.

> [!NOTE] Si estás en la vista "workspace" pero quieres trabajar en [traducir un archivo](how-to-translate-files.md) en lugar de revisar, puedes seleccionar la opción `Crowdsourcing` del menú desplegable.

## Revisar traducciones

![
Imagen - Vista de corrección](https://contribute.freecodecamp.org/images/crowdin/proofread.png)

<!--Add proofread/crowdsource button to the image-->

Aquí verás la lista de cadenas en el archivo seleccionado, con sus traducciones correspondientes. La traducción que se muestra aquí es la traducción que ha recibido la puntuación más alta (entre votos a favor y en contra) de la comunidad de traducción.

Mientras puedas ver _todas_ las traducciones propuestas para una cadena determinada, las puntuaciones de la comunidad (determinadas por los votos a favor y en contra) deben tenerse en cuenta al elegir cuál traducción aprobar. La comunidad puede revisar las traducciones propuestas y recomendar cuál es la más clara y precisa.

1. Este es el segmento original (en inglés).
2. Este es el segmento traducido que le corresponde. Aquí se mostrará la traducción propuesta más popular, según sus votos positivos y negativos.
3. Al hacer clic en este botón de tilde aprobarás esa traducción.
4. Crowdin mostrará el estado de cada segmento. `Done` (listo) significa que una traducción ha sido aprobada y que será descargada en el próximo pull de Crowdin. `Todo` (por hacer o "to do") significa que el segmento aún no ha sido revisado. `Hidden` (Oculto) significa que la cadena está bloqueada y _no debe traducirse_. `Comment` significa que la cadena de texto incluye un comentario.
5. Puedes usar las casillas de verificación para seleccionar varias traducciones y aprobarlas en un solo paso.
6. Aquí puedes ver las traducciones propuestas por la comunidad, sus puntajes de popularidad y las traducciones sugeridas por Crowdin.
7. Este botón muestra/oculta el panel del lado derecho, donde puedes ver traducciones, comentarios, la memoria de traducciones y el glosario de términos.
8. Crowdin muestra aquí los mensajes de error de las verificaciones de calidad (QA / quality assurance). En otras palabras, Crowdin te notificará si algo en la traducción no parece estar correcto. Estas traducciones deberían ser aprobadas cuidadosamente.

No se requieren acciones adicionales una vez que el archivo ha sido revisado.

> [!NOTE] Aprobar una cadena en la vista de revisión la marcará como completa y se descargará en nuestra próxima extracción de Crowdin a GitHub.

## Llegar hacer un revisor

Si tienes alguna pregunta o te interesa colaborar como revisor, ten la liberta de contactarnos en nuestra [sala de chat de contribuidores](https://chat.freecodecamp.org/channel/contributors). Generalmente, le concederemos acceso a la corrección si ha estado contribuyendo a freeCodeCamp durante un tiempo.

Nuestro equipo de personal y de moderadores de la comunidad buscan constantemente voluntarios amables como tú que nos ayuden a poner a disposición del mundo traducciones de alta calidad.

> [!NOTE] Crowdin te permite aprobar tus propias traducciones. Sin embargo, en general suele ser mejor permitir que otro corrector revise tus traducciones propuestas como medida adicional para asegurarse que no hayan errores.

## Creando un canal en Chat para un idioma mundial

Mayormente, te recomendamos que utilices la sala de chat de [contribuidores](https://chat.freecodecamp.org/channel/contributors) para toda la correspondencia. Sin embargo, si el equipo de traductores voluntarios crece para un idioma determinado, podemos considerar la creación de un canal de escape adicional para el idioma.

Si ya eres un revisor y estás interesado en tener un canal dedicado en nuestros servidores de chat para un idioma específico, [completa este formulario](https://forms.gle/XU5CyutrYCgDYaVZA).
