### GitHub und Open Source sind neu für mich. Wo sollte ich anfangen?

Lies unseren Leitfaden ["How to Contribute to Open Source"](https://github.com/freeCodeCamp/how-to-contribute-to-open-source). Es ist ein umfassendes Nachschlagewerk für einsteigerfreundliche Projekte. Und er enthält eine Menge Tipps für Open-Source-Beiträge.

### Was muss ich wissen, um zur Codebasis beizutragen?

freeCodeCamp läuft auf einem modernen JavaScript-Stack. Wenn du daran interessiert bist, zu unserer Codebasis beizutragen, solltest du mit JavaScript und einigen der von uns verwendeten Technologien wie Node.js, MongoDB, OAuth 2.0, React, Gatsby und Webpack vertraut sein.

### Kann ich die Ressourcen von freeCodeCamp übersetzen?

Ja - du kannst zu jeder der über 30 Sprachen beitragen, die wir auf unserer Übersetzungsplattform aktiviert haben.

In einigen Sprachen haben wir von Nutzern erstellte Übersetzungen online. Wir haben vor, das freeCodeCamp in mehrere wichtige Weltsprachen zu lokalisieren. Du kannst alles darüber in unserer [Ankündigung ](https://www.freecodecamp.org/news/world-language-translation-effort) lesen.

Wenn du daran interessiert bist, zu Übersetzungen beizutragen, stelle bitte sicher, dass du [diesen Leitfaden](how-to-translate-files.md) zuerst gelesen hast.

### Kann ich Artikel für die freeCodeCamp News oder Videos für den YouTube-Kanal von freeCodeCamp beisteuern?

Ja - du kannst zu unserem Newsblog und unserem YouTube-Kanal beitragen.

Wenn du daran interessiert bist, Artikel für freeCodeCamp News zu schreiben, schau dir bitte diesen [Veröffentlichungsleitfaden](https://www.freecodecamp.org/news/how-to-write-for-freecodecamp/) an. Lies außerdem unseren [Stil-Leitfaden](https://www.freecodecamp.org/news/developer-news-style-guide/), denn er wird dir helfen, aussagekräftige und effektive Artikel zu schreiben.

Um uns zu helfen, Lehrvideos für unseren YouTube-Kanal zu erstellen, kannst du den [YouTube-Kanal-Leitfaden](https://www.freecodecamp.org/news/how-to-contribute-to-the-freecodecamp-community-youtube-channel-b86bce4c865/) hier einsehen.

### Wie kann ich einen neuen Fehler melden?

Wenn du glaubst, dass du einen Fehler gefunden hast, lies zuerst den ["Hilfe, ich habe einen Fehler gefunden"](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) Artikel und folge den Anweisungen darin.

Wenn du sicher bist, dass es sich um einen neuen Fehler handelt, kannst du einen neuen Issue auf GitHub erstellen. Gib so viele Informationen wie möglich an, damit wir den Fehler reproduzieren können. Wir haben eine vorgefertigte Issue-Vorlage, die dir dabei hilft.

Bitte beachte, dass diese GitHub Issues für Codebasis-bezogene Probleme und Diskussionen gedacht sind - nicht um Hilfe beim Programmieren zu bekommen. Im Zweifelsfall solltest du [Hilfe im Forum suchen](https://forum.freecodecamp.org), bevor du ein GitHub Issue erstellst.

### Wie kann ich ein Sicherheitsproblem melden?

Bitte erstelle keine GitHub Issues für Sicherheitsprobleme. Schicke stattdessen bitte eine E-Mail an `security@freecodecamp.org` und wir werden uns sofort darum kümmern.

### Ich bin ein Student. Kann ich für akademische Credits an einem Feature arbeiten?

Ja. Bitte beachte, dass wir nicht in der Lage sind, uns an Fristen oder Papierkram zu halten, die von deiner Hochschule oder Universität vorgeschrieben werden könnten. Wir erhalten viele Pull-Requests und Code-Beiträge von freiwilligen Entwicklern, und wir respektieren ihre Zeit und ihren Einsatz. Aus Respekt vor allen anderen Beiträgen werden wir keinen PR eine besondere Priorität einräumen, nur weil sie einen Schulbezug haben.

Wir bitten dich, vorausschauend zu planen und deine Beiträge zum Code in diesem Sinne zu gestalten.

### Was bedeuten die verschiedenen Labels, mit denen die Themen versehen sind?

Die Code-Maintainer [Sortieren](https://en.wikipedia.org/wiki/Software_bug#Bug_management) Issues und Pull Requests nach ihrer Priorität, Schwere und anderen Faktoren. Du kannst [hier](https://github.com/freecodecamp/freecodecamp/labels) ein komplettes Glossar mit ihren Bedeutungen finden.

### Wo fange ich an, wenn ich an einem Issue arbeiten will?

Du solltest über [**`help wanted`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22help+wanted%22) oder [**`first timers only`**](https://github. com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22first+timers+only%22) Issues gehen, um einen schnellen Überblick darüber zu bekommen, was für dich zur Verfügung steht.

> [!TIP] **`help wanted`** Issues sind frei zugänglich und du musst nicht um Erlaubnis bitten, bevor du sie bearbeitest. Issues mit dem **`first timers only`**-Label sind jedoch spezielle Issues, die für Leute gedacht sind, die noch nicht zur freeCodeCamp Codebasis beigetragen haben.

### Ich habe einen Schreibfehler gefunden. Sollte ich ein Issue melden, bevor ich einen Pull Request erstellen kann?

Bei Schreibfehlern und anderen Änderungen am Wortlaut kannst du direkt Pull Requests öffnen, ohne zuerst ein Issue zu erstellen. Bitte vergewissere dich, dass du Details in der Pull Request-Beschreibung angibst, damit wir deinen Beitrag besser verstehen und überprüfen können - selbst wenn es nur eine kleine Änderung ist.

Bitte erstelle ein Issue, wenn du größere Aspekte der Codebasis oder des Studienplans diskutieren möchtest.

### Wie kann ich mir ein Issue zuweisen lassen?

Normalerweise weisen wir die Issues nur langjährigen Mitwirkenden zu. Stattdessen befolgen wir die folgende Richtlinie, um allen gerecht zu werden:

1. Wir werden höchstwahrscheinlich den ersten Pull Request mergen, der das Problem behebt.
2. Wenn mehrere Mitwirkende etwa zur gleichen Zeit einen Pull Request für dasselbe Problem öffnen, geben wir dem Pull Request den Vorrang, der das Problem am besten löst. Einige der Dinge, die wir berücksichtigen:
   - Hast du auch Tests durchgeführt?
   - Hast du alle Anwendungsfälle erfasst?
   - Hast du sichergestellt, dass alle Tests erfolgreich waren und dass alles lokal funktioniert?
3. Schließlich geben wir Pull Requests Vorrang, die unseren empfohlenen Richtlinien entsprechen.
   - Hast du die Checkliste für Pull Requests befolgt?
   - Hast du deinem Pull Request einen aussagekräftigen Titel gegeben?

### Ich bin daran interessiert, beim freeCodeCamp als Moderator zu mitzuwirken. Wo sollte ich anfangen?

Unsere Community-Moderatoren sind unsere Helden. Ihre freiwilligen Beiträge machen das freeCodeCamp zu einer sicheren und einladenden Gemeinschaft.

In erster Linie möchten wir, dass du ein aktiver Teilnehmer in der Gemeinschaft bist und dich an unseren [Verhaltenskodex](https://www.freecodecamp.org/news/code-of-conduct/) hältst (und ihn nicht nur durchsetzt).

Hier sind einige empfohlene Wege für einige unserer Plattformen:

- Ein **Discord/Chat**-Moderator zu sein, eine aktive Präsenz in unserem Chat zu haben und positiv auf andere einzugehen und gleichzeitig zu lernen und zu üben, wie man mit möglichen Konflikten umgeht, die entstehen können.
- Ein **Forum**-Moderator zu sein, ähnlich wie ein Chat-Moderator, eine aktive Präsenz zu zeigen und mit anderen Forumspostern in Kontakt zu treten, andere in ihrem Lernprozess zu unterstützen und auf Wunsch auch Feedback zu geben. Sieh dir das [Das Handbuch für Subforenleiter](https://forum.freecodecamp.org/t/the-subforum-leader-handbook/326326) für weitere Informationen an.
- Als **GitHub**-Moderator hilfst du bei der Bearbeitung von GitHub-Issues, die aufgeworfen werden und versuchst (idealerweise), Lösungen für diese Issues vorzuschlagen, die dann von anderen (oder von dir selbst) aufgegriffen werden.

Sei insgesamt respektvoll gegenüber anderen. Wir sind Menschen überall auf der Welt. Mit Blick darauf denke auch daran, eine ermutigende oder unterstützende Sprache zu verwenden und achte auf die interkulturelle Kommunikation.

Wenn du das oben genannte **eine Weile lang konsequent praktizierst** und unsere anderen Moderatoren dich empfehlen, wird ein Mitarbeiter auf dich zukommen und dich in das Moderatorenteam aufnehmen. Open-Source-Arbeit ist freiwillige Arbeit und unsere Zeit ist begrenzt. Wir erkennen an, dass dies wahrscheinlich auch in deiner Situation der Fall ist. Deshalb betonen wir **konsequent** zu sein, anstatt sich rund um die Uhr (24/7) in der Community zu engagieren.

Take a look at our [Moderator Handbook](moderator-handbook.md) for a more exhaustive list of other responsibilities and expectations we have of our moderators.

### Ich komme mit etwas nicht weiter, das in dieser Dokumentation nicht enthalten ist.

**Frag einfach nach Hilfe in:**

- Der `Contributors` Kategorie von [unserem Community Forum](https://forum.freecodecamp.org/c/contributors).
- Dem `#Contributors` Kanal auf[ unserem Chat Server](https://chat.freecodecamp.org/channel/contributors).

Wir freuen uns, dir dabei zu helfen, einen Beitrag zu den Themen zu leisten, an denen du gerne arbeiten möchtest. Wenn du uns in den entsprechenden Issue Threads Fragen stellst, helfen wir dir gerne weiter. Achte darauf, dass du nach deiner Frage suchst, bevor du eine neue stellst.

Vielen Dank im Voraus für deine Höflichkeit und Geduld. Vergiss nicht, dass diese Community hauptsächlich von Freiwilligen betrieben wird.

### Zusätzliche Hilfe

Wenn du Fragen zum Stack, zur Architektur der Codebasis, zu Übersetzungen oder zu anderen Themen hast, kannst du dich gerne an unser Team [im Forum](https://forum.freecodecamp.org/g/team) wenden.

**Du kannst unserem Entwicklerteam eine E-Mail schicken an: `dev[at]freecodecamp.org`**
