### Sono nuovo in GitHub e nel mondo Open Source. Da dove dovrei iniziare?

Leggi la nostra guida ["Come contribuire all'Open Source"](https://github.com/freeCodeCamp/how-to-contribute-to-open-source). E' un compendio completo per progetti adatti a neofiti. Ed essa include un sacco di consigli per contribuire all'open source.

### Cosa devo sapere per contribuire alla codebase?

freeCodeCamp è basata su uno stack JavaScript moderno. Se hai interesse a contribuire, dovrai avere un po' di familiarità con JavaScript e alcune delle tecnologie che usiamo come Node.js, MongoDB, OAuth 2.0, React, Gatsby e Webpack.

### Posso tradurre le risorse di freeCodeCamp?

Sì, puoi contribuire a ognuna delle oltre 30 lingue abilitate sulla nostra piattaforma di traduzione.

Abbiamo le traduzioni fatte dagli utenti live in alcune lingue. Abbiamo intenzione di localizzare freeCodeCamp nelle lingue più usate nel mondo. Puoi leggere tutto su questo argomento nel nostro [annuncio](https://www.freecodecamp.org/news/world-language-translation-effort).

Se sei interessato a contribuire alla traduzione per favore assicurati di [leggere questa guida](how-to-translate-files.md) come prima cosa.

### Posso contribuire articoli alla Pubblicazione di freeCodeCamp o video al canale YouTube?

Sì, puoi contribuire alla nostra pubblicazione e al canale YouTube.

Se vuoi scrivere articoli per la Pubblicazione di freeCodeCamp, per favore visita la nostra  [guida di pubblicazione](https://www.freecodecamp.org/news/how-to-write-for-freecodecamp/). In aggiunta, per favore leggi la nostra [guida allo stile](https://www.freecodecamp.org/news/developer-news-style-guide/) che ti aiuterà a scrivere altricoli migliori e più efficaci.

Per aiutarci a fare video educativi sul nostro canale YouTube, puoi seguire la [guida al canale YouTube qui](https://www.freecodecamp.org/news/how-to-contribute-to-the-freecodecamp-community-youtube-channel-b86bce4c865/).

### Come posso segnalare un nuovo bug?

Se pensi di avere trovato un bug, prima leggi l'articolo ["Help I've Found a Bug" (Aiuto ho trovato un bug)](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) e segui le istruzioni.

Se sei certo che sia un nuovo bug, vai avanti e crea una issue su GitHub. Assicurati di includere quante più informazioni possibili in modo che sia possibile riprodurre il bug. Abbiamo un template predefinito per quando si crea un'issue per aiutarti in questo.

Per favore nota che queste issue in GitHub sono per problemi e discussioni sulla codebase, non per chiedere aiuto mentre impari a programmare. Se hai dubbi, dovresti [chiedere assistenza sul forum](https://forum.freecodecamp.org) prima di creare un'issue su GitHub.

### Come posso segnalare un problema di sicurezza?

Per favore non creare issue su GitHub per problemi di sicurezza. Invece invia una email a `security@freecodecamp.org` e controlleremo immediatamente.

### Sono uno studente. Posso lavorare su una funzionalità ottenendo crediti accademici?

Sì. Per favore nota che non siamo in grado di impegnarci in alcun modo per limiti di tempo o questioni burocratiche che possono essere richiesti dal tuo college o dalla tua università. Riceviamo molte pull request e contributi al codice da sviluppatori volontari, e rispettiamo il loro tempo e i loro sforzi. Per rispetto di tutti gli altri nostri contributori, non daremo ad alcuna PR priorità speciale solo perché è legata a impegni accademici.

Ti chiediamo di pianificare in anticipo e lavorare sui contributi al codice tenendolo a mente.

### Cosa significano queste diverse etichette che vengono associate alle issue?

I manutentori del codice [smistano](https://en.wikipedia.org/wiki/Software_bug#Bug_management) issue e pull request a seconda della loro priorità, gravità e altri fattori. Puoi trovare [un glossario dei loro significati qui.](https://github.com/freecodecamp/freecodecamp/labels).

### Da dove comincio se voglio lavorare su una issue?

Dovresti guardare le issue taggate con [**`help wanted`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22help+wanted%22) o [**`first timers only`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22first+timers+only%22) per una veloce overview di cosa è disponibile per lavorarci su.

> [!TIP] Le issue **`help wanted`** sono a disposizione, e non devi chiedere permessi per poterci lavorare. Tuttavia, le issue con l'etichetta **`first timers only`** sono problemi speciali che sono stati progettati per le persone che non hanno contribuito al codice freeCodeCamp prima d'ora.

### Ho trovato un errore di ortografia. Dovrei creare un'issue prima di poter fare una pull request?

Per errori di ortografia e altre modifiche di parole, puoi aprire direttamente una pull request senza prima creare un'issue. Per favore assicurati di scrivere dettagli nella descrizione della pull request per aiutarci a capire e rivedere il tuo contributo, anche se è un piccolo cambiamento.

Per favore crea un'issue se vuoi discutere aspetti più ampi del codebase o del curriculum.

### Come posso farmi assegnare un'issue?

In genere non assegnamo issue se non a contributori esperti. Invece, seguiamo la seguente politica per essere giusti nei confronti di tutti:

1. Abbiamo maggiori probabilità di fare il merge della prima pull request che affronta il problema.
2. Nel caso di più contributori che aprono una pull request per lo stesso problema all'incirca allo stesso tempo, daremo la priorità alla pull request che affronta al meglio la questione. Alcune delle cose che consideriamo:
   - Hai incluso dei test?
   - Hai coperto tutti i casi d'uso?
   - Ti sei assicurato che tutti i test siano superati, e confermi che tutto funziona localmente?
3. Infine, diamo la priorità alle pull request che seguono le nostre linee guida raccomandate.
   - Hai seguito la checklist delle pull request?
   - Hai dato alla tua pull request un titolo significativo?

### Ho interesse ad essere moderatore per freeCodeCamp. Da dove dovrei iniziare?

I nostri moderatori della community sono i nostri eroi. Il loro contributo volontario rende freeCodeCamp una community sicura e accogliente.

Prima di tutto, avremmo bisogno che tu sia un partecipate attivo della nostra community, e segua il nostro [codice di condotta](https://www.freecodecamp.org/italian/news/codice-di-condotta/) (non solo che tu lo faccia rispettare).

Ecco alcuni percorsi consigliati per alcune delle nostre piattaforme:

- Per essere un moderatore per **Discord/Chat**, abbi una presenza attiva nella nostra chat e avendo interazioni attive con gli altri, e intanto imparando e praticando come gestire potenziali conflitti che possano insrgere.
- Per essere un moderatore del **Forum**, in maniera simile ai moderatori, abbi una presenza attiva e interagisci con gli utenti, supportando gli altri nel loro percorso di crescita e dando feedback quando richiesto. Dai un occhiata al [The Subforum Leader Handbook](https://forum.freecodecamp.org/t/the-subforum-leader-handbook/326326) per maggiori informazioni.
- Per essere un moderatore su **GitHub**, aiuta a processare le issue su GitHub che sono create per vedere se sono valide e (idealmente) prova a proporre soluzioni per queste issue che possono essere applicate da altri (o da te stesso).

Nel complesso, rispetta gli altri. Siamo umani in tutto il mondo. Con questo in mente, perfavore considera anche l'uso di linguaggio incoraggiante e supportivo e tieni a mente la comunicazione tra culture diverse.

Se metti in pratica quando sopra **consistentemente per un po'** e i nostri moderatori ti raccomandato, un membro dello staff si farà avanti e ti darà il benvenuto nel team dei moderatori. Il lavoro open source è un lavoro volontario e il nostro tempo è limitato. Riconosciamo che questo è probabilmente vero anche nel tuo caso. Quindi sottolineiamo essere  **consistenti** piuttosto che impegnarsi nella comunità 24/7.

Dai un'occhiata al [Manuale per moderatori](moderator-handbook.md) per una lista più esaustiva di altre responsabilità e aspettative che abbiamo del nostro team di moderatori.

### Sono bloccato su qualcosa che non è incluso in questa documentazione.

**Se hai bisogno chiedi liberamente aiuto in:**

- La categoria `Contributors` del [forum della nostra community](https://forum.freecodecamp.org/c/contributors).
- Il canale `#Contributors` sul nostro [chat server](https://chat.freecodecamp.org/channel/contributors).

Siamo entusiasti di aiutarti a contribuire in ognuno degli ambiti su cui vorresti lavorare. Se fai domande sul relativo thread di un'issue, saremo lieti di rispondere. Assicurati di fare una ricerca per la tua domanda prima di porne una nuova.

Ti ringraziamo in anticipo per essere educato e paziente. Ricordati che questa comunità è gestita principalmente da volontari.

### Assistenza aggiuntiva

Se hai domande sullo stack, sull'architettura del database, sulle traduzioni, o su qualsiasi altra cosa, sentiti libero di rivolgerti al nostro team dello staff [sul forum](https://forum.freecodecamp.org/g/team).

**Puoi scrivere una mail allo staff di sviluppo a: `dev[at]freecodecamp.org`**
