# セキュリティポリシー

このドキュメントでは、コードベース、運用プラットフォーム、および脆弱性の報告方法に関するセキュリティポリシーについて概説します。

## 脆弱性の報告

脆弱性を発見したと思われる場合は、_責任を持って報告してください_。 セキュリティ問題のために GitHub Issue を作成しないでください。 その代わりに、`security@freecodecamp.org` にメールを送信してください。私たちが直ちに調査します。

お使いのマシンで使用できるオペレーティングシステムと Web ブラウザの **最新**、**安定**、および **更新** バージョンを使用していることを確認してください。

私たちのプラットフォームおよびユーザーの整合性に影響を与える可能性のある脆弱性について、責任ある開示をお願いします。

脆弱性が報告されたら、それを調査し誤検知ではないことを確認します。 詳細を明確にする必要がある場合は、ご連絡いたします。 発見した各問題について個別にレポートを提出することができます。

現時点ではいかなる報奨金も報酬も提供していませんが、その報告に多大なご尽力をいただいた場合、[殿堂入り](security-hall-of-fame.md) リストにお名前を掲示いたします。

私たちは、[「beg bounties」](https://www.troyhunt.com/beg-bounties/) カテゴリの SPF & DKIM 構成、または SSL サーバーテスト等に関する問題を報告するため、ツール & オンラインユーティリティを使用することを検討します。それらの報告に対して対応することはできません。

## プラットフォーム & コードベース

報告を受け付けるプラットフォームとコードベースのリストは以下のとおりです。

### 学習プラットフォーム

| バージョン  | ブランチ           | サポート | 有効な Web サイト              |
| ------ | -------------- | ---- | ------------------------ |
| 本番     | `prod-current` | 有    | `freecodecamp.org/learn` |
| ステージング | `prod-staging` | 有    | `freecodecamp.dev/learn` |
| 開発     | `main`         | 無    |                          |

### 公開プラットフォーム

| バージョン  | サポート | 有効な Web サイト                              |
| ------ | ---- | ---------------------------------------- |
| 本番     | 有    | `freecodecamp.org/news`                  |
| ローカライズ | 有    | `freecodecamp.org/<language>/news` |

### モバイルアプリ

| バージョン | サポート | 有効な Web サイト                                                      |
| ----- | ---- | ---------------------------------------------------------------- |
| 本番    | 有    | `https://play.google.com/store/apps/details?id=org.freecodecamp` |

上記とは別に、freeCodeCamp 組織で、GitHub にホストされているリポジトリの報告も受け付けています。

Ghost & Discourse のようなオープンソースソフトウェアを使用して、いくつかのプラットフォームをセルフホストします。 脆弱性を報告する場合は、アップストリームソフトウェアのバグではないことを確認してください。
